<!-- DO NOT EDIT: this file is automatically generated using scw-doc-gen -->
# Documentation for `scw apple-silicon`
Scaleway Apple silicon M1 as-a-Service is built using the latest generation of Apple Mac mini hardware (fifth generation).

These dedicated Mac mini M1s are designed for developing, building, testing, and signing applications for Apple devices, including iPhones, iPads, Mac computers and much more.

Get set to explore, learn and build on a dedicated Mac mini M1 with more performance and speed than you ever thought possible.

**Apple silicon as a Service comes with a minimum allocation period of 24 hours**.

Mac mini and macOS are trademarks of Apple Inc., registered in the U.S. and other countries and regions.
IOS is a trademark or registered trademark of Cisco in the U.S. and other countries and is used by Apple under license.
Scaleway is not affiliated with Apple Inc.

  
- [OS management commands](#os-management-commands)
  - [Get an Operating System (OS)](#get-an-operating-system-(os))
  - [List all Operating System (OS)](#list-all-operating-system-(os))
- [Apple silicon management commands](#apple-silicon-management-commands)
  - [Create a server](#create-a-server)
  - [Delete a server](#delete-a-server)
  - [Get a server](#get-a-server)
  - [List all servers](#list-all-servers)
  - [Reboot a server](#reboot-a-server)
  - [Reinstall a server](#reinstall-a-server)
  - [SSH into a server](#ssh-into-a-server)
  - [Update a server](#update-a-server)
  - [Wait for a server to reach a stable state](#wait-for-a-server-to-reach-a-stable-state)
- [Server-Types management commands](#server-types-management-commands)
  - [Get a server type](#get-a-server-type)
  - [List server types](#list-server-types)

  
## OS management commands

OS management commands


### Get an Operating System (OS)

Get an Operating System (OS).

**Usage:**

```
scw apple-silicon os get <os-id ...> [arg=value ...]
```


**Args:**

| Name |   | Description |
|------|---|-------------|
| os-id | Required | UUID of the OS you want to get |



### List all Operating System (OS)

List all Operating System (OS).

**Usage:**

```
scw apple-silicon os list [arg=value ...]
```


**Args:**

| Name |   | Description |
|------|---|-------------|
| server-type |  | List of compatible server type |
| name |  | Filter os by name (for eg. "11.1" will return "11.1.2" and "11.1" but not "12") |



## Apple silicon management commands

Apple silicon management commands


### Create a server

Create a server.

**Usage:**

```
scw apple-silicon server create [arg=value ...]
```


**Args:**

| Name |   | Description |
|------|---|-------------|
| name | Default: `<generated>` | Create a server with this given name |
| project-id |  | Project ID to use. If none is passed the default project ID will be used |
| type | Default: `M1-M` | Create a server of the given type |



### Delete a server

Delete a server.

**Usage:**

```
scw apple-silicon server delete <server-id ...> [arg=value ...]
```


**Args:**

| Name |   | Description |
|------|---|-------------|
| server-id | Required | UUID of the server you want to delete |



### Get a server

Get a server.

**Usage:**

```
scw apple-silicon server get <server-id ...> [arg=value ...]
```


**Args:**

| Name |   | Description |
|------|---|-------------|
| server-id | Required | UUID of the server you want to get |



### List all servers

List all servers.

**Usage:**

```
scw apple-silicon server list [arg=value ...]
```


**Args:**

| Name |   | Description |
|------|---|-------------|
| order-by | One of: `created_at_asc`, `created_at_desc` | The sort order of the returned servers |
| project-id |  | List only servers of this project ID |
| organization-id |  | List only servers of this organization ID |



### Reboot a server

Reboot a server.

**Usage:**

```
scw apple-silicon server reboot <server-id ...> [arg=value ...]
```


**Args:**

| Name |   | Description |
|------|---|-------------|
| server-id | Required | UUID of the server you want to reboot |



### Reinstall a server

Reinstall a server.

**Usage:**

```
scw apple-silicon server reinstall <server-id ...> [arg=value ...]
```


**Args:**

| Name |   | Description |
|------|---|-------------|
| server-id | Required | UUID of the server you want to reinstall |



### SSH into a server

Connect to distant server via the SSH protocol.

**Usage:**

```
scw apple-silicon server ssh <server-id ...> [arg=value ...]
```


**Args:**

| Name |   | Description |
|------|---|-------------|
| server-id | Required | Server ID to SSH into |
| username | Default: `m1` | Username used for the SSH connection |
| port | Default: `22` | Port used for the SSH connection |
| command |  | Command to execute on the remote server |
| zone | Default: `fr-par-1` | Zone to target. If none is passed will use default zone from the config |



### Update a server

Update a server.

**Usage:**

```
scw apple-silicon server update <name ...> [arg=value ...]
```


**Args:**

| Name |   | Description |
|------|---|-------------|
| server-id | Required | UUID of the server you want to update |
| name | Required | Updated name for your server |



### Wait for a server to reach a stable state

Wait for server to reach a stable state. This is similar to using --wait flag on other action commands, but without requiring a new action on the server.

**Usage:**

```
scw apple-silicon server wait <server-id ...> [arg=value ...]
```


**Args:**

| Name |   | Description |
|------|---|-------------|
| server-id | Required | ID of the server. |
| zone | Default: `fr-par-1` | Zone to target. If none is passed will use default zone from the config |


**Examples:**


Wait for a server to reach a stable state
```
scw apple-silicon server wait 11111111-1111-1111-1111-111111111111
```




## Server-Types management commands

Server-Types management commands


### Get a server type

Get a server technical details.

**Usage:**

```
scw apple-silicon server-type get <server-type ...> [arg=value ...]
```


**Args:**

| Name |   | Description |
|------|---|-------------|
| server-type | Required | Server type identifier |



### List server types

List all server types technical details.

**Usage:**

```
scw apple-silicon server-type list
```



