<!-- DO NOT EDIT: this file is automatically generated using scw-doc-gen -->
# Documentation for `scw container`
Container as a Service API
  
- [Container management commands](#container-management-commands)
  - [Create a new container](#create-a-new-container)
  - [Delete a container](#delete-a-container)
  - [Deploy a container](#deploy-a-container)
  - [Get a container](#get-a-container)
  - [List all your containers](#list-all-your-containers)
  - [Update an existing container](#update-an-existing-container)
- [Cron management commands](#cron-management-commands)
  - [Delete an existing cron](#delete-an-existing-cron)
  - [Get a cron](#get-a-cron)
  - [List all your crons](#list-all-your-crons)
- [Namespace management commands](#namespace-management-commands)
  - [Create a new namespace](#create-a-new-namespace)
  - [Delete an existing namespace](#delete-an-existing-namespace)
  - [Get a namespace](#get-a-namespace)
  - [List all your namespaces](#list-all-your-namespaces)
  - [Update an existing namespace](#update-an-existing-namespace)

  
## Container management commands

Container management commands.


### Create a new container

Create a new container.

**Usage:**

```
scw container container create [arg=value ...]
```


**Args:**

| Name |   | Description |
|------|---|-------------|
| namespace-id |  |  |
| name | Default: `<generated>` |  |
| environment-variables.value.{key} |  |  |
| min-scale |  |  |
| max-scale |  |  |
| memory-limit |  |  |
| timeout.seconds |  |  |
| timeout.nanos |  |  |
| privacy | One of: `unknown_privacy`, `public`, `private` |  |
| description |  |  |
| registry-image |  |  |
| max-concurrency |  |  |
| domain-name |  |  |
| protocol | One of: `unknown_protocol`, `http1`, `h2c` |  |
| port |  |  |
| secret-environment-variables.{index}.key |  |  |
| secret-environment-variables.{index}.value |  |  |
| http-option |  | Configure how HTTP and HTTPS requests are handled |
| region | Default: `fr-par`<br />One of: `fr-par` | Region to target. If none is passed will use default region from the config |



### Delete a container

Delete the container associated with the given id.

**Usage:**

```
scw container container delete <container-id ...> [arg=value ...]
```


**Args:**

| Name |   | Description |
|------|---|-------------|
| container-id | Required |  |
| region | Default: `fr-par`<br />One of: `fr-par` | Region to target. If none is passed will use default region from the config |



### Deploy a container

Deploy a container associated with the given id.

**Usage:**

```
scw container container deploy <container-id ...> [arg=value ...]
```


**Args:**

| Name |   | Description |
|------|---|-------------|
| container-id | Required |  |
| region | Default: `fr-par`<br />One of: `fr-par` | Region to target. If none is passed will use default region from the config |



### Get a container

Get the container associated with the given id.

**Usage:**

```
scw container container get <container-id ...> [arg=value ...]
```


**Args:**

| Name |   | Description |
|------|---|-------------|
| container-id | Required |  |
| region | Default: `fr-par`<br />One of: `fr-par` | Region to target. If none is passed will use default region from the config |



### List all your containers

List all your containers.

**Usage:**

```
scw container container list [arg=value ...]
```


**Args:**

| Name |   | Description |
|------|---|-------------|
| order-by | One of: `created_at_asc`, `created_at_desc`, `name_asc`, `name_desc` |  |
| namespace-id |  |  |
| name |  |  |
| project-id |  |  |
| organization-id |  |  |
| region | Default: `fr-par`<br />One of: `fr-par` | Region to target. If none is passed will use default region from the config |



### Update an existing container

Update the container associated with the given id.

**Usage:**

```
scw container container update <container-id ...> [arg=value ...]
```


**Args:**

| Name |   | Description |
|------|---|-------------|
| container-id | Required |  |
| environment-variables.value.{key} |  |  |
| min-scale |  |  |
| max-scale |  |  |
| memory-limit |  |  |
| timeout.seconds |  |  |
| timeout.nanos |  |  |
| redeploy |  |  |
| privacy | One of: `unknown_privacy`, `public`, `private` |  |
| description |  |  |
| registry-image |  |  |
| max-concurrency |  |  |
| domain-name |  |  |
| protocol | One of: `unknown_protocol`, `http1`, `h2c` |  |
| port |  |  |
| secret-environment-variables.{index}.key |  |  |
| secret-environment-variables.{index}.value |  |  |
| http-option |  | Configure how HTTP and HTTPS requests are handled |
| region | Default: `fr-par`<br />One of: `fr-par` | Region to target. If none is passed will use default region from the config |



## Cron management commands

Cron management commands.


### Delete an existing cron

Delete the cron associated with the given id.

**Usage:**

```
scw container cron delete <cron-id ...> [arg=value ...]
```


**Args:**

| Name |   | Description |
|------|---|-------------|
| cron-id | Required |  |
| region | Default: `fr-par`<br />One of: `fr-par` | Region to target. If none is passed will use default region from the config |



### Get a cron

Get the cron associated with the given id.

**Usage:**

```
scw container cron get <cron-id ...> [arg=value ...]
```


**Args:**

| Name |   | Description |
|------|---|-------------|
| cron-id | Required |  |
| region | Default: `fr-par`<br />One of: `fr-par` | Region to target. If none is passed will use default region from the config |



### List all your crons

List all your crons.

**Usage:**

```
scw container cron list [arg=value ...]
```


**Args:**

| Name |   | Description |
|------|---|-------------|
| order-by | One of: `created_at_asc`, `created_at_desc` |  |
| container-id |  |  |
| region | Default: `fr-par`<br />One of: `fr-par` | Region to target. If none is passed will use default region from the config |



## Namespace management commands

Namespace management commands.


### Create a new namespace

Create a new namespace.

**Usage:**

```
scw container namespace create [arg=value ...]
```


**Args:**

| Name |   | Description |
|------|---|-------------|
| name | Default: `<generated>` |  |
| environment-variables.value.{key} |  |  |
| project-id |  | Project ID to use. If none is passed the default project ID will be used |
| description |  |  |
| secret-environment-variables.{index}.key |  |  |
| secret-environment-variables.{index}.value |  |  |
| region | Default: `fr-par`<br />One of: `fr-par` | Region to target. If none is passed will use default region from the config |



### Delete an existing namespace

Delete the namespace associated with the given id.

**Usage:**

```
scw container namespace delete <namespace-id ...> [arg=value ...]
```


**Args:**

| Name |   | Description |
|------|---|-------------|
| namespace-id | Required |  |
| region | Default: `fr-par`<br />One of: `fr-par` | Region to target. If none is passed will use default region from the config |



### Get a namespace

Get the namespace associated with the given id.

**Usage:**

```
scw container namespace get <namespace-id ...> [arg=value ...]
```


**Args:**

| Name |   | Description |
|------|---|-------------|
| namespace-id | Required |  |
| region | Default: `fr-par`<br />One of: `fr-par` | Region to target. If none is passed will use default region from the config |



### List all your namespaces

List all your namespaces.

**Usage:**

```
scw container namespace list [arg=value ...]
```


**Args:**

| Name |   | Description |
|------|---|-------------|
| order-by | One of: `created_at_asc`, `created_at_desc`, `name_asc`, `name_desc` |  |
| name |  |  |
| project-id |  |  |
| organization-id |  |  |
| region | Default: `fr-par`<br />One of: `fr-par` | Region to target. If none is passed will use default region from the config |



### Update an existing namespace

Update the space associated with the given id.

**Usage:**

```
scw container namespace update <namespace-id ...> [arg=value ...]
```


**Args:**

| Name |   | Description |
|------|---|-------------|
| namespace-id | Required |  |
| environment-variables.value.{key} |  |  |
| description |  |  |
| secret-environment-variables.{index}.key |  |  |
| secret-environment-variables.{index}.value |  |  |
| region | Default: `fr-par`<br />One of: `fr-par` | Region to target. If none is passed will use default region from the config |



