<!-- DO NOT EDIT: this file is automatically generated using scw-doc-gen -->
# Documentation for `scw function`
Function as a Service API
  
- [Cron management commands](#cron-management-commands)
  - [Delete an existing cron](#delete-an-existing-cron)
  - [Get a cron](#get-a-cron)
  - [List all your crons](#list-all-your-crons)
- [Function management commands](#function-management-commands)
  - [Create a new function](#create-a-new-function)
  - [Delete a function](#delete-a-function)
  - [Deploy a function](#deploy-a-function)
  - [Get a function](#get-a-function)
  - [Get a download URL of a function](#get-a-download-url-of-a-function)
  - [Get an upload URL of a function](#get-an-upload-url-of-a-function)
  - [List all your functions](#list-all-your-functions)
  - [Update an existing function](#update-an-existing-function)
- [Logs management commands](#logs-management-commands)
  - [List your application logs](#list-your-application-logs)
- [Function namespace management commands](#function-namespace-management-commands)
  - [Create a new namespace](#create-a-new-namespace)
  - [Delete an existing namespace](#delete-an-existing-namespace)
  - [Get a namespace](#get-a-namespace)
  - [List all your namespaces](#list-all-your-namespaces)
  - [Update an existing namespace](#update-an-existing-namespace)
- [Runtime management commands](#runtime-management-commands)
  - [List function runtimes](#list-function-runtimes)

  
## Cron management commands

Cron management commands.


### Delete an existing cron

Delete the cron associated with the given id.

**Usage:**

```
scw function cron delete <cron-id ...> [arg=value ...]
```


**Args:**

| Name |   | Description |
|------|---|-------------|
| cron-id | Required |  |
| region | Default: `fr-par`<br />One of: `fr-par` | Region to target. If none is passed will use default region from the config |



### Get a cron

Get the cron associated with the given id.

**Usage:**

```
scw function cron get <cron-id ...> [arg=value ...]
```


**Args:**

| Name |   | Description |
|------|---|-------------|
| cron-id | Required |  |
| region | Default: `fr-par`<br />One of: `fr-par` | Region to target. If none is passed will use default region from the config |



### List all your crons

List all your crons.

**Usage:**

```
scw function cron list [arg=value ...]
```


**Args:**

| Name |   | Description |
|------|---|-------------|
| order-by | One of: `created_at_asc`, `created_at_desc` |  |
| function-id |  |  |
| region | Default: `fr-par`<br />One of: `fr-par` | Region to target. If none is passed will use default region from the config |



## Function management commands

Function management commands.


### Create a new function

Create a new function.

**Usage:**

```
scw function function create [arg=value ...]
```


**Args:**

| Name |   | Description |
|------|---|-------------|
| name | Default: `<generated>` |  |
| namespace-id |  |  |
| environment-variables.value.{key} |  |  |
| min-scale |  |  |
| max-scale |  |  |
| runtime | One of: `unknown_runtime`, `golang`, `python`, `python3`, `node8`, `node10`, `node14` |  |
| memory-limit |  |  |
| timeout.seconds |  |  |
| timeout.nanos |  |  |
| handler |  |  |
| privacy | One of: `unknown_privacy`, `public`, `private` |  |
| description |  |  |
| secret-environment-variables.{index}.key |  |  |
| secret-environment-variables.{index}.value |  |  |
| http-option |  | Configure how HTTP and HTTPS requests are handled |
| region | Default: `fr-par`<br />One of: `fr-par` | Region to target. If none is passed will use default region from the config |



### Delete a function

Delete the function associated with the given id.

**Usage:**

```
scw function function delete <function-id ...> [arg=value ...]
```


**Args:**

| Name |   | Description |
|------|---|-------------|
| function-id | Required |  |
| region | Default: `fr-par`<br />One of: `fr-par` | Region to target. If none is passed will use default region from the config |



### Deploy a function

Deploy a function associated with the given id.

**Usage:**

```
scw function function deploy <function-id ...> [arg=value ...]
```


**Args:**

| Name |   | Description |
|------|---|-------------|
| function-id | Required |  |
| region | Default: `fr-par`<br />One of: `fr-par` | Region to target. If none is passed will use default region from the config |



### Get a function

Get the function associated with the given id.

**Usage:**

```
scw function function get <function-id ...> [arg=value ...]
```


**Args:**

| Name |   | Description |
|------|---|-------------|
| function-id | Required |  |
| region | Default: `fr-par`<br />One of: `fr-par` | Region to target. If none is passed will use default region from the config |



### Get a download URL of a function

Get a download URL for a function associated with the given id.

**Usage:**

```
scw function function get-download-url <function-id ...> [arg=value ...]
```


**Args:**

| Name |   | Description |
|------|---|-------------|
| function-id | Required |  |
| region | Default: `fr-par`<br />One of: `fr-par` | Region to target. If none is passed will use default region from the config |



### Get an upload URL of a function

Get an upload URL of a function associated with the given id.

**Usage:**

```
scw function function get-upload-url <function-id ...> [arg=value ...]
```


**Args:**

| Name |   | Description |
|------|---|-------------|
| function-id | Required |  |
| content-length |  |  |
| region | Default: `fr-par`<br />One of: `fr-par` | Region to target. If none is passed will use default region from the config |



### List all your functions

List all your functions.

**Usage:**

```
scw function function list [arg=value ...]
```


**Args:**

| Name |   | Description |
|------|---|-------------|
| order-by | One of: `created_at_asc`, `created_at_desc`, `name_asc`, `name_desc` |  |
| namespace-id |  |  |
| name |  |  |
| project-id |  |  |
| organization-id |  |  |
| region | Default: `fr-par`<br />One of: `fr-par` | Region to target. If none is passed will use default region from the config |



### Update an existing function

Update the function associated with the given id.

**Usage:**

```
scw function function update <function-id ...> [arg=value ...]
```


**Args:**

| Name |   | Description |
|------|---|-------------|
| function-id | Required |  |
| environment-variables.value.{key} |  |  |
| min-scale |  |  |
| max-scale |  |  |
| memory-limit |  |  |
| timeout.seconds |  |  |
| timeout.nanos |  |  |
| redeploy |  |  |
| handler |  |  |
| privacy | One of: `unknown_privacy`, `public`, `private` |  |
| description |  |  |
| secret-environment-variables.{index}.key |  |  |
| secret-environment-variables.{index}.value |  |  |
| http-option |  | Configure how HTTP and HTTPS requests are handled |
| region | Default: `fr-par`<br />One of: `fr-par` | Region to target. If none is passed will use default region from the config |



## Logs management commands

Logs management commands.


### List your application logs

List your application logs.

**Usage:**

```
scw function logs list [arg=value ...]
```


**Args:**

| Name |   | Description |
|------|---|-------------|
| function-id | Required |  |
| order-by | One of: `timestamp_desc`, `timestamp_asc` |  |
| region | Default: `fr-par`<br />One of: `fr-par` | Region to target. If none is passed will use default region from the config |



## Function namespace management commands

Function namespace management commands.


### Create a new namespace

Create a new namespace.

**Usage:**

```
scw function namespace create [arg=value ...]
```


**Args:**

| Name |   | Description |
|------|---|-------------|
| name | Default: `<generated>` |  |
| environment-variables.value.{key} |  |  |
| project-id |  | Project ID to use. If none is passed the default project ID will be used |
| description |  |  |
| secret-environment-variables.{index}.key |  |  |
| secret-environment-variables.{index}.value |  |  |
| region | Default: `fr-par`<br />One of: `fr-par` | Region to target. If none is passed will use default region from the config |



### Delete an existing namespace

Delete the namespace associated with the given id.

**Usage:**

```
scw function namespace delete <namespace-id ...> [arg=value ...]
```


**Args:**

| Name |   | Description |
|------|---|-------------|
| namespace-id | Required |  |
| region | Default: `fr-par`<br />One of: `fr-par` | Region to target. If none is passed will use default region from the config |



### Get a namespace

Get the namespace associated with the given id.

**Usage:**

```
scw function namespace get <namespace-id ...> [arg=value ...]
```


**Args:**

| Name |   | Description |
|------|---|-------------|
| namespace-id | Required |  |
| region | Default: `fr-par`<br />One of: `fr-par` | Region to target. If none is passed will use default region from the config |



### List all your namespaces

List all your namespaces.

**Usage:**

```
scw function namespace list [arg=value ...]
```


**Args:**

| Name |   | Description |
|------|---|-------------|
| order-by | One of: `created_at_asc`, `created_at_desc`, `name_asc`, `name_desc` |  |
| name |  |  |
| project-id |  |  |
| organization-id |  |  |
| region | Default: `fr-par`<br />One of: `fr-par` | Region to target. If none is passed will use default region from the config |



### Update an existing namespace

Update the space associated with the given id.

**Usage:**

```
scw function namespace update <namespace-id ...> [arg=value ...]
```


**Args:**

| Name |   | Description |
|------|---|-------------|
| namespace-id | Required |  |
| environment-variables.value.{key} |  |  |
| description |  |  |
| secret-environment-variables.{index}.key |  |  |
| secret-environment-variables.{index}.value |  |  |
| region | Default: `fr-par`<br />One of: `fr-par` | Region to target. If none is passed will use default region from the config |



## Runtime management commands

Runtime management commands.


### List function runtimes

List available function runtimes.

**Usage:**

```
scw function runtime list [arg=value ...]
```


**Args:**

| Name |   | Description |
|------|---|-------------|
| region | Default: `fr-par`<br />One of: `fr-par` | Region to target. If none is passed will use default region from the config |



